#include <stdio.h>
/*#include "/usr/local/express/include/express.h"*/
#include <math.h>

#include "smfa.h"
#include "decl.h"

#define TEST 0
#define DEBUG 0

#if TEST
/*----------------------------------------------------------------------*/
main()
{

	FILE* fp;
	int *map, max_vertices;
	vertex_t *vertex;

	fp = fopen("final", "r");
	fscanf(fp,"%d",&max_vertices);

	map = MEM(int , max_vertices);
	vertex = MEM(vertex_t, max_vertices);

	if (read_graph(fp, vertex, map, max_vertices) < 0)
		exit(2);             /* Some error in reading graph */

}
#endif
/*-----------------------------------------------------------------------*/
   
FILE *open_file(fname, mode)
char *fname;
int mode;
{

   FILE *fin;


   if ( mode == READ )
		fin = fopen(fname, "r");
   else {                      /* mode is WRITE */
		if ( mode == WRITE ) {
        	fin = fopen(fname, "w");	  /* Everyone writes to a diff file */
		}
		else {
   			fprintf(stderr, "\n Can Not Open File: llegal Mode specified\n");
			exit(50);            /* Illegal Mode specified */
		}
	}

   if ( fin == (FILE *) 0) {
      fprintf(stderr, "fails to open file\n");
      exit(13);
   }


   return (fin);

}
  
/*-------------------------------------------------------------------------*/

int read_max_vertices(fp)
FILE *fp;
{
   int max_vertices;


   fscanf(fp, "%d", &max_vertices);

   return (max_vertices);

}

/*----------------------------------------------------------------------*/

int 
read_graph(fp, vertex, max_vertices)
FILE *fp;
vertex_t *vertex;
int max_vertices;
{	
	int i, info;

	for (i=0;fscanf(fp,"%d",&info) != EOF;i++) {
		vertex[i].deg = info;
		read_vrtx_info(fp, i, vertex);
	}

	if (i == max_vertices)
		return i;      /* Successful read, return max vertices */
	else 
		return -1;      /* There is some error */
}
/*-----------------------------------------------------------------------*/
void 
read_vrtx_info(fp, i, vertex)
FILE *fp;
int i;
vertex_t *vertex;
{
	int j, info;

	fscanf(fp,"%d",&info);
    fscanf(fp,"%d",&info);
    vertex[i].wt = info;


	if (vertex[i].deg > 0) {
	    if ((vertex[i].egwt = MEM(double,vertex[i].deg)) == NULL) {
   	       exit(10);     /* Out Of memory */
   	    }
		if ((vertex[i].nabor = MEM(int, vertex[i].deg)) == NULL) {
			exit(10); /* Out of memory */
		}     			
		for (j = 0; j<vertex[i].deg; j++) {
			fscanf(fp, "%d",&info);
			vertex[i].egwt[j] = info;  
            fscanf(fp, "%d",&info);
            vertex[i].nabor[j] = info-1;   /* GSN start from 0 instead of 1 */
		}
	}
	else 
		if (vertex[i].deg == 0) {
			vertex[i].nabor = NULL;
			vertex[i].egwt = NULL;
		}
		else 
			exit(21);  /* Illegal vertex degree */
}
/*------------------------------------------------------------------------*/
	
		
int *generate_solution( spin, num_vertices )
double **spin;
int num_vertices;
{
    int i, j, proc =0;
    FILE *fout;
	int *map;

    fout = open_file("log_smfa_out", WRITE);

    map = MEM(int, num_vertices);
    if ( map == NULL)
            printf("Outta memory while mallocing for MAP\n");


	for ( i=0; i < num_vertices; i++) {
        proc =0; 
		for ( j=0; j < NPROC; j++)
			if ( spin[i][j] >= 0.0 )
				proc = proc + (int) pow( 2.0, (double)j);

		map[i] = proc;
        fprintf(fout, "GSN: %d PROC: %d\n", i, proc);

	}

	fclose(fout);
	return map;

}


void find_solution_quality( map, num_vertices, vertex )
int *map;
int num_vertices;
vertex_t *vertex;
{

	int i, maxload;
    int count_cut_edges = 0, j;
    int *count_load, proc;
    int nproc;

    nproc = (int) pow( 2.0, (double) NPROC);

    count_load = MEM(int, nproc);
    if ( count_load == NULL)
            printf("Outta memory while mallocing for count_load\n");

    for( i=0; i < nproc; i++ )
        count_load[i] = 0;

    for( i=0; i < num_vertices; i++) {
        for ( j=0; j < vertex[i].deg; j++)
            if ( map[i] != map[vertex[i].nabor[j]] )
                count_cut_edges++;

        count_load[map[i]]++;
    }
    maxload = count_load[0];

    for( i=0; i < nproc; i++ ) {
        if ( count_load[i] > maxload )
            maxload = count_load[i];
    }

/*  Prof ranka Did not want this :-<
    printf(" Quality Factor: %f\n",
    ( (num_vertices/nproc) / (maxload+0.10*count_cut_edges) ) );
*/
    printf(" Quality Factor: %f\n",
    ( (num_vertices/nproc) / (maxload+0.10*count_cut_edges/nproc) ) );

	free(map);
}


int maxdouble(p1, p2, size)
double *p1;
double *p2;
int size;
{

    if ( *p2 > *p1)
        *p1 = *p2;

    return 0;
}


