

/* #####################################
   ##                                 ##
   ##  User Modifiable Stuff Starts : ##
   ##                                 ##
   #####################################
*/

#define NPROC 2              /* Number of Processors for data mapping */
#define TEMP0     15000.0    /* To keep iterations of outter while loop
					 		  * to just 4 for testing purpose make it 5.0
							  */







/* #####################################
   ##                                 ##
   ##  User Modifiable Stuff ENDS     ##
   ##                                 ##
   #####################################
*/

#define WRITE 0
#define READ  1


/* Defined below is the data structure for the graph representing
*  currently the data mapping problem instance. For each graph node 
*  the following information is stored :
*
*     - degree of the node of the undirected graph
*     - pointers to all the nodes which are connected to given node
*     - pointers to proc# of each nabor
*     - Edge weights of each of the edges eminating from the given node
*     - weight assigned to each node
*
*  The "wt" represents the computational load for the node, "egwt" denotes
*  the communication happening between nodes.
*/
 
typedef struct vertx_rec {
    int   deg;                  /* Vertex degree */
    int  *nabor;                /* Pointer to neighbours of a node */
    double wt;                   /* Weight of the node */
    double  *egwt;               /* Edge weights */
} vertex_t;


#define NEW(type)  (type *)malloc(sizeof(type))
#define MEM(type,size)  (type *)calloc(size,sizeof(type))

